#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

void stampa_matrice(int** m, int righe, int colonne){
int i,j;
   for(i=0;i<righe;i++){ 
      for(j=0;j<colonne;j++)
       printf("%d ",m[i][j]);
      printf("\n");
     }
}

void init_matrice(int** m, int righe, int colonne){
int i,j;
   for(i=0;i<righe;i++){ 
      for(j=0;j<colonne;j++)
       m[i][j]=rand()%10;
     }
}

void trasposta(int ** m, int n)
{
int i,j,mem;
for(i=0;i<n-1;i++)
 {
  for(j=i+1;j<n;j++)
   {
    mem=m[i][j];
    m[i][j]=m[j][i];
    m[j][i]=mem;
   }
 }
}

int** alloca_matrice(int n, int m){
/*  alloco il vettore delle righe, ogni elemento è un puntatore*/
int **matrice = (int **) malloc ( n * sizeof (int * ) ) ;
int i;
for ( i = 0 ; i < n ; i ++)
	matrice[ i ] = ( int * ) malloc ( m * sizeof ( int ) ) ;

return matrice;
}

int** alloca_matrice_quadrata(int n){
	return alloca_matrice(n, n);
}

int main(){
   
int **matrice, **matriceq, i;

int r,c;

srand(time(0));
printf("Inserisci il numero di righe: ");
scanf("%d", &r);
printf("Inserisci il numero di colonne: ");
scanf("%d", &c);

matrice =  alloca_matrice(r, c);
init_matrice(matrice, r, c);
printf("matrice: \n");
stampa_matrice(matrice, r,c);

matriceq = alloca_matrice_quadrata(r);
init_matrice(matriceq, r, r);
printf("matrice quadrata: \n");
stampa_matrice(matriceq, r,r);
trasposta(matriceq, r);
printf("matrice quadrata trasposta: \n");
stampa_matrice(matriceq, r,r);

for ( i = 0 ; i < r ; i ++)
	free(matrice[ i ]);
free(matrice) ;

}
