#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
int* alloca_array(int n_elementi)
{
   int * nuovo_array = (int *)calloc(n_elementi,sizeof(int));
   
   if(nuovo_array == NULL)
     {
	printf("Memoria esaurita\n");
	exit(1);
     }
   return nuovo_array;
   
}

void copia_array(int*v, int*u, int lung)
{
   int i;
   for(i=0;i<lung;i++)
     u[i]=v[i];
}


//espande v di lunghezza lung di n_elem
int* espandi_array(int* v, int lung, int n_elem)
{
   int* nuovo = (int *)calloc(lung+n_elem,sizeof(int));
   if(nuovo == NULL)
     {
	printf("Memoria esaurita\n");
	exit(1);
     }
   
   copia_array(v, nuovo, lung);
   free(v);
   //v=nuovo;
   return nuovo;
}

void stampa_array(int* v, int lung)
{ 
   int i;
   for(i=0; i<lung; i++)
     {
	printf("%6d%c", v[i], i%5 == 4 ? '\n' : ' ');
     }
   printf("\n");
}

void bubble_sort(int* v, int n_elem)
{
   
     int i, tmp;
     int alto=n_elem;
     //v={2,4,5,6}
     //alto = 1
     while (alto > 0)
     {
	
	for (i=0; i<alto-1; i++) 
	  if (v[i]>v[i+1]) /* scambiate il '>' con '<' se volete un ordinamento decrescente */
	    {
	       tmp = v[i]; 
	       v[i] = v[i+1]; 
	       v[i+1] = tmp;
	    }
	printf("alto= %d \n",alto);
	stampa_array(v,n_elem);
	alto--; 
     }
}


int main()
{
   
   int numero, *array, i;
   char buffer[15];
   int allocati;
   
   numero=10;
   printf("Numero di elementi dell'array: %d\n", numero);
   
   array = alloca_array(numero);
   srand(time(0));
   for(i=0; i<numero; i++)
     {
	array[i] = rand()%100;
     }
   
   
   printf("Valori degli elementi\n");
   
   stampa_array(array, numero);
   
   bubble_sort(array, numero);
   printf("Valori degli elementi ordinati\n");
   
   stampa_array(array, numero);
   
   printf("\nNumero elementi %d\n", numero);
   printf("Dimensione elemento %d\n", sizeof(int));
   
   
   array = espandi_array(array, numero, 5);
   
   numero = numero + 5;
   
   stampa_array(array, numero);
   
   free(array);
   printf("Memoria Liberata\n");
   
   return 0;
}
